<?php

/**
 * Implementation of hook_views_data().
 */
function freeagent_views_data() {

  // Freeagent users table.
  $data['freeagent_users']['table']['group'] = t('FreeAgent Users');
  $data['freeagent_users']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent users'),
    'help' => t('FreeAgent users'),
  );
  $data['freeagent_users']['id'] = array(
    'title' => t('User id'),
    'help' => t('The id of the FreeAgent user.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_user_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_users_drupal_accounts',
      'base field' => 'fa_id',
      'field' => 'id',
      'label' => t('freeagent user drupal account'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_user_id',
    ),
  );
  $data['freeagent_users']['timeslip_user_id'] = array(
    'title' => t('Timeslip user id'),
    'help' => t('The id of the FreeAgent timeslip user.'),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_timeslips',
      'base field' => 'user_id',
      'field' => 'id',
      'label' => t('timeslip user id'),
    ),
  );
  $data['freeagent_users']['first_name'] = array(
    'title' => t('First name'),
    'help' => t('The first name of the FreeAgent user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_users']['last_name'] = array(
    'title' => t('Last name'),
    'help' => t('The last name of the FreeAgent user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_users']['full_name'] = array(
    'title' => t('Full name'),
    'help' => t('The full name of the FreeAgent user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_users']['email'] = array(
    'title' => t('Email'),
    'help' => t('The email address of the FreeAgent user.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_users']['role'] = array(
    'title' => t('Role'),
    'help' => t('The role the user has in FreeAgent.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_users']['permission_level'] = array(
    'title' => t('Permission level'),
    'help' => t('The permission level of the FreeAgent user.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_users']['opening_mileage'] = array(
    'title' => t('Opening mileage'),
    'help' => t('The opening mileage for the FreeAgent user.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_users']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the user was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_users']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the user was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );


  // Freeagent contacts table.
  $data['freeagent_contacts']['table']['group'] = t('FreeAgent Contacts');
  $data['freeagent_contacts']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent contacts'),
    'help' => t('FreeAgent contacts'),
  );
  $data['freeagent_contacts']['id'] = array(
    'title' => t('Contact id'),
    'help' => t('The id of the FreeAgent contact.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_contact_id',
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_contact_id',
    ),
  );
  $data['freeagent_contacts']['first_name'] = array(
    'title' => t('First name'),
    'help' => t('The first name of the FreeAgent contact.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['last_name'] = array(
    'title' => t('Last name'),
    'help' => t('The last name of the FreeAgent contact.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['organisation_name'] = array(
    'title' => t('Organisation name'),
    'help' => t('The organisation name of the contact.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['email'] = array(
    'title' => t('Email'),
    'help' => t('The email address of the FreeAgent contact.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['billing_email'] = array(
    'title' => t('Billing email'),
    'help' => t('The billing email address of the FreeAgent contact.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['phone_number'] = array(
    'title' => t('Phone number'),
    'help' => t("The contact's phone number."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['address1'] = array(
    'title' => t('Address line 1'),
    'help' => t("Line 1 of the contact's street address"),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['address2'] = array(
    'title' => t('Address line 2'),
    'help' => t("Line 2 of the contact's street address"),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['address3'] = array(
    'title' => t('Address line 3'),
    'help' => t("Line 3 of the contact's street address"),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['town'] = array(
    'title' => t('Town'),
    'help' => t("The contact's town."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['region'] = array(
    'title' => t('Region'),
    'help' => t("The contact's region."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['country'] = array(
    'title' => t('Country'),
    'help' => t("The contact's country."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['locale'] = array(
    'title' => t('Locale'),
    'help' => t("Two character character code for the contact's locale."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['status'] = array(
    'title' => t('Status'),
    'help' => t("The contact's status."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['charge_sales_tax'] = array(
    'title' => t('Charge sales tax?'),
    'help' => t("Whether sales tax should be charged."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_contacts']['contact_name_on_invoices'] = array(
    'title' => t('Display contact name on invoices?'),
    'help' => t('Whether or not to display the contact name on invoices.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_contacts']['uses_contact_invoice_sequence'] = array(
    'title' => t('Use contact invoice sequence?'),
    'help' => t('Whether or not to use a per-contact invoice sequence.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_contacts']['account_balance'] = array(
    'title' => t('Account balance'),
    'help' => t("The contact's account balance."),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_contacts']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the contact was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_contacts']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the contact was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );


  // Freeagent projects table.
  $data['freeagent_projects']['table']['group'] = t('FreeAgent Projects');
  $data['freeagent_projects']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent projects'),
    'help' => t('FreeAgent projects'),
  );
  $data['freeagent_projects']['id'] = array(
    'title' => t('Project id'),
    'help' => t('The id of the FreeAgent project.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_project_id',
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_project_id',
    ),
  );
  $data['freeagent_projects']['name'] = array(
    'title' => t('Name'),
    'help' => t('The project name.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_projects']['contact_id'] = array(
    'title' => t('Contact id'),
    'help' => t('The contact that this project is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_contact_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_contacts',
      'base field' => 'id',
      'label' => t('contact'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_contact_id',
    ),
  );
  $data['freeagent_projects']['status'] = array(
    'title' => t('Status'),
    'help' => t('The project status.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_projects']['budget_units'] = array(
    'title' => t('Budget units'),
    'help' => t('The units used for the project budget, e.g. hours, days.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_projects']['currency'] = array(
    'title' => t('Currency'),
    'help' => t('The project currency.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_projects']['billing_period'] = array(
    'title' => t('Billing period'),
    'help' => t('Whether the contact is billed by the hour, day, etc.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_projects']['budget'] = array(
    'title' => t('Budget'),
    'help' => t('The project budget.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_projects']['normal_billing_rate'] = array(
    'title' => t('Normal billing rate'),
    'help' => t('The default task billing rate.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_projects']['hours_per_day'] = array(
    'title' => t('Hours per day'),
    'help' => t('Number of working hours in a day.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_projects']['uses_project_invoice_sequence'] = array(
    'title' => t('Use project invoice sequence?'),
    'help' => t('Whether or not to use a per-project invoice sequence.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_projects']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the project was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_projects']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the project was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );


  // Freeagent tasks table.
  $data['freeagent_tasks']['table']['group'] = t('FreeAgent Tasks');
  $data['freeagent_tasks']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent tasks'),
    'help' => t('FreeAgent tasks'),
  );
  $data['freeagent_tasks']['id'] = array(
    'title' => t('Task id'),
    'help' => t('The id of the FreeAgent task.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_task_id',
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_task_id',
    ),
  );
  $data['freeagent_tasks']['name'] = array(
    'title' => t('Name'),
    'help' => t('The task name.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_tasks']['project_id'] = array(
    'title' => t('Project id'),
    'help' => t('The project that this task is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_project_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_projects',
      'base field' => 'id',
      'label' => t('project'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_project_id',
    ),
  );
  $data['freeagent_tasks']['status'] = array(
    'title' => t('Status'),
    'help' => t('The task status.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_tasks']['billing_period'] = array(
    'title' => t('Billing period'),
    'help' => t('Whether the project is billed by the hour, day, etc.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_tasks']['is_billable'] = array(
    'title' => t('Is billable?'),
    'help' => t('Whether or not the task is billable.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_tasks']['billing_rate'] = array(
    'title' => t('Billing rate'),
    'help' => t('The task billing rate.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_tasks']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the task was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_tasks']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the task was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );


  // Freeagent timeslips table.
  $data['freeagent_timeslips']['table']['group'] = t('FreeAgent Timeslips');
  $data['freeagent_timeslips']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent timeslips'),
    'help' => t('FreeAgent timeslips'),
  );
  $data['freeagent_timeslips']['id'] = array(
    'title' => t('Timeslip id'),
    'help' => t('The id of the FreeAgent timeslip.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_timeslips']['user_id'] = array(
    'title' => t('User id'),
    'help' => t('The user who created the timeslip.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_user_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_users',
      'base field' => 'id',
      'label' => t('user'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_user_id',
    ),
  );
  $data['freeagent_timeslips']['project_id'] = array(
    'title' => t('Project id'),
    'help' => t('The project that this timeslip is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_project_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_projects',
      'base field' => 'id',
      'label' => t('project'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_project_id',
    ),
  );
  $data['freeagent_timeslips']['task_id'] = array(
    'title' => t('Task id'),
    'help' => t('The task that this timeslip is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_task_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_tasks',
      'base field' => 'id',
      'label' => t('task'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_task_id',
    ),
  );
  $data['freeagent_timeslips']['hours'] = array(
    'title' => t('Hours'),
    'help' => t('The number of hours logged on the timeslip.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_hours',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_timeslips']['comment'] = array(
    'title' => t('Comment'),
    'help' => t('The timeslip comment.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_timeslips']['dated_on'] = array(
    'title' => t('Date'),
    'help' => t('Date of the timeslip.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_timeslips']['day'] = array(
    'title' => t('Day'),
    'help' => t('Day of the timeslip.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_timeslips']['month'] = array(
    'title' => t('Month'),
    'help' => t('Month of the timeslip.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_month',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_timeslips']['year'] = array(
    'title' => t('Year'),
    'help' => t('Year of the timeslip.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_timeslips']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the timeslip was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_timeslips']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the timeslip was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );

  // Freeagent invoices table.
  $data['freeagent_invoices']['table']['group'] = t('FreeAgent Invoices');
  $data['freeagent_invoices']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent invoices'),
    'help' => t('FreeAgent invoices'),
  );
  $data['freeagent_invoices']['id'] = array(
    'title' => t('Invoice id'),
    'help' => t('The id of the FreeAgent invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['contact_id'] = array(
    'title' => t('Contact id'),
    'help' => t('The contact who created the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_contact_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_contacts',
      'base field' => 'id',
      'label' => t('contact'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_contact_id',
    ),
  );
  $data['freeagent_invoices']['reference'] = array(
    'title' => t('Reference'),
    'help' => t('The invoice reference.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_invoices']['status'] = array(
    'title' => t('Status'),
    'help' => t("The invoice's status."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_invoices']['currency'] = array(
    'title' => t('Currency'),
    'help' => t("The invoice's currency."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_invoices']['exchange_rate'] = array(
    'title' => t('Exchange rate'),
    'help' => t('Any exchange rate associated with the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['net_value'] = array(
    'title' => t('Net value'),
    'help' => t('The net value of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['sales_tax_value'] = array(
    'title' => t('Sales tax value'),
    'help' => t('The sales tax value of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['total_value'] = array(
    'title' => t('Total value'),
    'help' => t('The total value of invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['paid_value'] = array(
    'title' => t('Paid value'),
    'help' => t('The value paid on the invoice so far.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['due_value'] = array(
    'title' => t('Due value'),
    'help' => t('The value outstanding on the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['comments'] = array(
    'title' => t('Comments'),
    'help' => t('Comments which appear on the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_invoices']['payment_terms_in_days'] = array(
    'title' => t('Payment terms in days'),
    'help' => t('The number of days in which the contact has to pay the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['ec_status'] = array(
    'title' => t('EC Status'),
    'help' => t('EC Status'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_invoices']['omit_header'] = array(
    'title' => t('Omit header?'),
    'help' => t('Whether or not the header is to be omitted on the generated invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['always_show_bic_and_iban'] = array(
    'title' => t('Always show BIC and IBAN?'),
    'help' => t('Whether or not to always show BIC and IBAN details.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['show_project_name'] = array(
    'title' => t('Display project name on invoice?'),
    'help' => t('Whether or not to display the project name on the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['dated_on'] = array(
    'title' => t('Date'),
    'help' => t('Date of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_invoices']['day'] = array(
    'title' => t('Day'),
    'help' => t('Day of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['month'] = array(
    'title' => t('Month'),
    'help' => t('Month of the invoice.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_month',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['year'] = array(
    'title' => t('Year'),
    'help' => t('Year of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['due_on'] = array(
    'title' => t('Due date'),
    'help' => t('When the invoice is due to be paid by.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_invoices']['due_day'] = array(
    'title' => t('Day of due date'),
    'help' => t('Due Day of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['due_month'] = array(
    'title' => t('Month of due date'),
    'help' => t('Due Month of the invoice.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_month',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['due_year'] = array(
    'title' => t('Year of due date'),
    'help' => t('Due Year of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['paid_on'] = array(
    'title' => t('Paid Date'),
    'help' => t('Date the invoice was paid on.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_invoices']['paid_day'] = array(
    'title' => t('Paid Day'),
    'help' => t('Paid Day of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['paid_month'] = array(
    'title' => t('Paid Month'),
    'help' => t('Paid Month of the invoice.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_month',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['paid_year'] = array(
    'title' => t('Paid Year'),
    'help' => t('Paid Year of the invoice.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_invoices']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the invoice was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_invoices']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the invoice was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );

  // Freeagent categories table.
  $data['freeagent_categories']['table']['group'] = t('FreeAgent Categories');
  $data['freeagent_categories']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent categories'),
    'help' => t('FreeAgent categories'),
  );
  $data['freeagent_categories']['id'] = array(
    'title' => t('Category id'),
    'help' => t('The id of the FreeAgent category.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_categories']['description'] = array(
    'title' => t('Description'),
    'help' => t('The category name or description.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_categories']['tax_reporting_name'] = array(
    'title' => t('Tax reporting name'),
    'help' => t('The tax reporting category.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_categories']['nominal_code'] = array(
    'title' => t('Nominal code'),
    'help' => t('The category nominal code.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_categories']['allowable_for_tax'] = array(
    'title' => t('Allowable for tax?'),
    'help' => t('Whether or not this category is allowable against tax.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_categories']['auto_sales_tax_rate'] = array(
    'title' => t('Auto sales tax rate'),
    'help' => t('Auto sales tax rate'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_categories']['category_type'] = array(
    'title' => t('Category type'),
    'help' => t('The type of category.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );

  // Freeagent expenses table.
  $data['freeagent_expenses']['table']['group'] = t('FreeAgent Expenses');
  $data['freeagent_expenses']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent expenses'),
    'help' => t('FreeAgent expenses'),
  );
  $data['freeagent_expenses']['id'] = array(
    'title' => t('Expense id'),
    'help' => t('The id of the FreeAgent expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['user_id'] = array(
    'title' => t('User id'),
    'help' => t('The user who created the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_user_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_users',
      'base field' => 'id',
      'label' => t('user'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_user_id',
    ),
  );
  $data['freeagent_expenses']['category_id'] = array(
    'title' => t('Category id'),
    'help' => t('The category that this expense is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_category_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_categories',
      'base field' => 'id',
      'label' => t('category'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_category_id',
    ),
  );
  $data['freeagent_expenses']['currency'] = array(
    'title' => t('Currency'),
    'help' => t('The expense currency.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_expenses']['gross_value'] = array(
    'title' => t('Gross value'),
    'help' => t('Expense gross value.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['native_gross_value'] = array(
    'title' => t('Native gross value'),
    'help' => t('The native gross value of the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['sales_tax_rate'] = array(
    'title' => t('Sales tax rate'),
    'help' => t('The sales tax rate on the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['sales_tax_value'] = array(
    'title' => t('Sales tax value'),
    'help' => t('The sales tax value on the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['native_sales_tax_value'] = array(
    'title' => t('Native sales tax value'),
    'help' => t('The native sales tax value on expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['manual_sales_tax_amount'] = array(
    'title' => t('Manual sales tax amount'),
    'help' => t('The manual sales tax amount on the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['mileage'] = array(
    'title' => t('Mileage'),
    'help' => t('The expense mileage.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['engine_size_index'] = array(
    'title' => t('Engine size index'),
    'help' => t('Engine size index'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['engine_type_index'] = array(
    'title' => t('Engine type index'),
    'help' => t('Engine type index'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['initial_rate_mileage'] = array(
    'title' => t('Initial rate mileage'),
    'help' => t('Initial rate mileage'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['have_vat_receipt'] = array(
    'title' => t('Is this a VAT receipt?'),
    'help' => t('Whether or not this is a VAT receipt.'),
    'field' => array(
      'handler' => 'views_handler_field_boolean',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_boolean_operator',
      'type' => 'yes-no',
      'use equal' => TRUE,
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['description'] = array(
    'title' => t('Description'),
    'help' => t('The expense description.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_expenses']['dated_on'] = array(
    'title' => t('Date'),
    'help' => t('Date of the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_expenses']['day'] = array(
    'title' => t('Day'),
    'help' => t('Day of the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['month'] = array(
    'title' => t('Month'),
    'help' => t('Month of the expense.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_month',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['year'] = array(
    'title' => t('Year'),
    'help' => t('Year of the expense.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_expenses']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the expense was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_expenses']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the expense was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );

  // Freeagent bills table.
  $data['freeagent_bills']['table']['group'] = t('FreeAgent Bills');
  $data['freeagent_bills']['table']['base'] = array(
    'field' => 'id',
    'title' => t('FreeAgent bills'),
    'help' => t('FreeAgent bills'),
  );
  $data['freeagent_bills']['id'] = array(
    'title' => t('Bill id'),
    'help' => t('The id of the FreeAgent bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['contact_id'] = array(
    'title' => t('Contact id'),
    'help' => t('The contact that this bill is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_contact_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_contacts',
      'base field' => 'id',
      'label' => t('contact'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_contact_id',
    ),
  );
  $data['freeagent_bills']['project_id'] = array(
    'title' => t('Project id'),
    'help' => t('The project that this bill is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_project_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_projects',
      'base field' => 'id',
      'label' => t('project'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_project_id',
    ),
  );
  $data['freeagent_bills']['category_id'] = array(
    'title' => t('Category id'),
    'help' => t('The category that this bill is associated with.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_category_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_categories',
      'base field' => 'id',
      'label' => t('category'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_category_id',
    ),
  );
  $data['freeagent_bills']['reference'] = array(
    'title' => t('Reference'),
    'help' => t('The bill reference.'),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_bills']['status'] = array(
    'title' => t('Status'),
    'help' => t("The bill's status."),
    'field' => array(
      'handler' => 'views_handler_field',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_string',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_string',
    ),
  );
  $data['freeagent_bills']['sales_tax_rate'] = array(
    'title' => t('Sales tax rate'),
    'help' => t('The sales tax rate of the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['sales_tax_value'] = array(
    'title' => t('Sales tax value'),
    'help' => t('The sales tax value of the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['total_value'] = array(
    'title' => t('Total value'),
    'help' => t('The total value of bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['paid_value'] = array(
    'title' => t('Paid value'),
    'help' => t('The value paid on the bill so far.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['due_value'] = array(
    'title' => t('Due value'),
    'help' => t('The value outstanding on the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
      'float' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['due_on'] = array(
    'title' => t('Due date'),
    'help' => t('When the bill is due to be paid by.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_bills']['due_day'] = array(
    'title' => t('Day of due date'),
    'help' => t('Due Day of the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['due_month'] = array(
    'title' => t('Month of due date'),
    'help' => t('Due Month of the bill.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_month',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['due_year'] = array(
    'title' => t('Year of due date'),
    'help' => t('Due Year of the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['dated_on'] = array(
    'title' => t('Date'),
    'help' => t('Date of the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_bills']['day'] = array(
    'title' => t('Day'),
    'help' => t('Day of the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['month'] = array(
    'title' => t('Month'),
    'help' => t('Month of the bill.'),
    'field' => array(
      'handler' => 'freeagent_handler_field_month',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['year'] = array(
    'title' => t('Year'),
    'help' => t('Year of the bill.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_numeric',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
    ),
  );
  $data['freeagent_bills']['created'] = array(
    'title' => t('Created'),
    'help' => t('When the bill was created.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );
  $data['freeagent_bills']['updated'] = array(
    'title' => t('Updated'),
    'help' => t('When the bill was last updated.'),
    'field' => array(
      'handler' => 'views_handler_field_date',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort_date',
    ),
    'filter' => array(
      'handler' => 'views_handler_filter_date',
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_date',
    ),
  );

  // Freeagent users drupal accounts link table.
  $data['freeagent_users_drupal_accounts']['table']['group'] = t('FreeAgent Users - Drupal accounts');
  $data['freeagent_users_drupal_accounts']['fa_id'] = array(
    'title' => t('FreeAgent user id'),
    'help' => t('The freeagent user.'),
    'field' => array(
      'handler' => 'views_handler_field_numeric',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'handler' => 'freeagent_handler_filter_user_id',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'freeagent_users',
      'base field' => 'fa_id',
      'label' => t('freeagent user'),
    ),
    'argument' => array(
      'handler' => 'freeagent_handler_argument_user_id',
    ),
  );
  $data['freeagent_users_drupal_accounts']['uid'] = array(
    'title' => t('Drupal user id'),
    'help' => t('The drupal user.'),
    'field' => array(
      'handler' => 'views_handler_field_user',
      'click sortable' => TRUE,
    ),
    'sort' => array(
      'handler' => 'views_handler_sort',
    ),
    'filter' => array(
      'title' => t('Current user'),
      'handler' => 'views_handler_filter_user_current',
    ),
    'relationship' => array(
      'handler' => 'views_handler_relationship',
      'base' => 'users',
      'base field' => 'uid',
      'field' => 'uid',
      'label' => t('drupal user'),
    ),
    'argument' => array(
      'handler' => 'views_handler_argument_numeric',
      //'handler' => 'views_handler_argument_user_uid',
    ),
  );

  return $data;
}

