<?php

/**
 * @file
 * Definition of freeagent_handler_field_month.
 */

/**
 * Render a field as a numeric value, or as a month label.
 *
 * @ingroup views_field_handlers
 */
class freeagent_handler_field_month extends views_handler_field {
  function option_definition() {
    $options = parent::option_definition();

    $options['use_month_label'] = array('default' => FALSE, 'bool' => TRUE);

    return $options;
  }

  function options_form(&$form, &$form_state) {
    $form['use_month_label'] = array(
      '#type' => 'checkbox',
      '#title' => t('Display month label'),
      '#description' => t('If checked, the month name will be displayed instead of the number.'),
      '#default_value' => $this->options['use_month_label'],
    );
    parent::options_form($form, $form_state);
  }

  function render($values) {
    $value = $this->get_value($values);

    if (!empty($this->options['use_month_label'])) {
      $months = array(
        1 => t('Jan'),
        2 => t('Feb'),
        3 => t('Mar'),
        4 => t('Apr'),
        5 => t('May'),
        6 => t('Jun'),
        7 => t('Jul'),
        8 => t('Aug'),
        9 => t('Sep'),
        10 => t('Oct'),
        11 => t('Nov'),
        12 => t('Dec'),
      );
      if (!empty($months[$value])) {
        $value = $months[$value];
      }
    }

    return $this->sanitize_value($value);
  }
}
